#####################################################
# leonov - The Launchpad Desktop Client
# Copyright (C) 2008 Stephan Hermann
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#####################################################

from PyQt4.QtCore import QObject, Qt, SIGNAL, SLOT, QString, QStringList, QThread
from leonov.backend import LPDB,LPDB_Users, LPDB_Projects
import logging

class SQL_ProjectThread(QThread):
    def __init__(self,projectlist):
        QThread.__init__(self)
        self.projectlist=projectlist
        
    def run(self):
        logging.getLogger("leonov.kde.models.threads.sqlworkers").debug("SQL_UserThread running")
        lpdb=LPDB()
        lp_users=LPDB_Users(lpdb)
        lp_projects=LPDB_Projects(lpdb)
        projects = set(i[1] for i in lp_projects.select())
        users = set(i[2] for i in lp_users.select())
        
        logging.getLogger("leonov.kde.models.threads.sqlworkers").debug("SQL_UserThread diff_user")
        #(lp_user.realname,str(lp_user))
        # need set here for one entry per user
        diff_users = set((i.registrar.realname, i.registrar.lplogin) for i in self.projectlist if not i.registrar.lplogin in users)
        logging.getLogger("leonov.kde.models.threads.sqlworkers").debug("SQL_UserThread insert user")
        lp_users.add_many(diff_users)
        
        users = dict((i[2], i[0]) for i in lp_users.select())
        #(project.name,project.summary,project.url,user_id,int(project.license_reviewed),project.registered)
        diff_projects = ((i.name, i.summary, i.url, users[i.registrar.lplogin], int(i.license_reviewed), i.registered)  for i in self.projectlist if not i.name in projects) #remove set later
        
        logging.getLogger("leonov.kde.models.threads.sqlworkers").debug("SQL_UserThread insert project")
        lp_projects.add_many(diff_projects)
        logging.getLogger("leonov.kde.models.threads.sqlworkers").debug("SQL_UserThread commit")
        lpdb.commit()
        lpdb.close()
        logging.getLogger("leonov.kde.models.threads.sqlworkers").debug("SQL_UserThread FINI")
        self.emit(SIGNAL("projectListDatabaseFinished"))
            
        
                
                
                
            
